'''A resource for scripters writing for PVKII
Written By: J3ff
www.pvkii.com
www.eventscripts.com'''
import es, gamethread

info = es.AddonInfo()
info.name = 'PVKII Tools'
info.version = '0.3.1'
info.url = 'mattie.info/cs/forums/index.php'
info.basename = 'pvktools'
info.author = 'Jeff Hoogland'

es.ServerVar('pvktools',info.version,'PVKII Tools Version - Made by Jeff91').makepublic()

pvkAmmo = {'parrot':'002','flintlock':'003','crossbow':'004','longbow':'005','blunderbuss':'006','throwaxe':'007'}

#Begin Events
#Local Events
def player_hurt(ev):
	userid = int(ev['userid'])
	Track(userid).Update('health',pvkPlayer(userid).GetHealth())
	Track(userid).Update('armor',pvkPlayer(userid).GetArmor())
	Track(userid).Update('attacker',ev['attacker'])
	Track(userid).Update('weapon',pvkPlayer(userid).GetAttributes()['weapon'])
def player_spawn(ev):
	Track(ev['userid']).Reset()
#Global Events
def es_map_start(ev):
	es.loadevents('declare', 'addons/eventscripts/pvktools/events.res')

def load():
	pvkLoop()

def pvkLoop():
	for id in es.getUseridList():
		values = Tracking(id).Get()
		if values['health'] != values['last health'] or values['armor'] != values['last armor']:
			damage = values['last health']-values['health']
			if damage > 0:
				es.event('initialize', 'player_damage')
				es.event('setint', 'userid', values['userid'])
				es.event('setint', 'attacker', values['attacker'])
				es.event('setint', 'dmg_health', damage)
				es.event('setint', 'dmg_armor', values['last armor']-values['armor'])
				es.event('setint', 'armor', values['armor'])
				es.event('setint', 'health', values['health'])
				es.event('setstring', 'weapon', values['weapon'])
				es.event('fire', 'player_damage')
				Track(id).Reset()
			elif damage < 0:
				Tracking(id).Update('last health', values['health'])
	gamethread.delayed(.1, pvkLoop)

def filterTeams(teams):
	teams.replace('s', '1')
	teams.replace('p', '2')
	teams.replace('v', '3')
	teams.replace('k', '4')
def getPlayerList(filter=None):
	return getUseridList(filter)
def getUseridList(filter=None):
	idList = []
	if not filter:
		return es.getUseridList()
	filter = filterTeams(filter)
	for id in es.getUseridList():
		good = 0
		team = es.getplayerteam(id)
		dead = es.getplayerprop(id, "CBasePlayer.pl.deadflag")
		if team in filter:
			good = 1
		if 'd' in filter and not dead:
			good = 0
		if 'a' in filter and dead:
			good = 0
		if good:
			idList.append(id)
	return idList
Tracking = {}
class Track:
	global Tracking
	def __init__(self, userid):
		self.userid = int(es.getuserid(userid))
		if not Tracking.has_key(self.userid):
			Tracking[self.userid] = {}
		self.key = Tracking[self.userid]
		self.pvkPlayer = pvkPlayer(self.userid)
	def Reset(self):
		self.key['health'], self.key['last health'], self.key['armor'], self.key['last armor'], self.key['attacker'], self.key['weapon'] = self.pvkPlayer.GetHealth(), self.pvkPlayer.GetHealth(), self.pvkPlayer.GetArmor(), self.pvkPlayer.GetArmor(), 0, 0
	def Update(self, value, amount):	
		self.key[value] = amount
	def Get(self):
		return {'health':self.key['health'],'last health':self.key['last health'], 'armor':self.key['armor'], 'last armor':self.key['last armor'], 'attacker':self.key['attacker'], 'weapon':self.key['weapon']}
pvkPlayers = {}
class pvkPlayer:
	global pvkPlayers
	def __init__(self, userid):
		self.userid = int(es.getuserid(userid))
		if not pvkPlayers.has_key(self.userid):
			pvkPlayers[self.userid] = {}
		self.refreshAttributes()
		self.key = pvkPlayers[self.userid]
	def refreshAttributes(self):
		try:
			self.attributes = es.createplayerlist(self.userid)[self.userid]
		except:
			es.dbgmsg(0, 'PVKTools Error: Player has left the server.')
	def GetAttributes(self):
		return self.attributes
	def GetMaxHealth(self):
		return es.getplayerprop(self.userid, 'CPVK2Player.m_iMaxHealth')
	def SetMaxHealth(self, amount):
		es.setplayerprop(self.userid, 'CPVK2Player.m_iMaxHealth', amount)
	def GetMaxArmor(self):
		return es.getplayerprop(self.userid, 'CPVK2Player.m_iMaxArmor')
	def SetMaxArmor(self, amount):
		es.setplayerprop(self.userid, 'CPVK2Player.m_iMaxArmor', amount)
	def GetArmor(self):
		return es.getplayerprop(self.userid, 'CPVK2Player.m_iArmorValue')
	def SetArmor(self, amount):
		es.setplayerprop(self.userid, 'CPVK2Player.m_iArmorValue', amount)
	def GetArmor(self):
		return es.getplayerprop(self.userid, 'CPVK2Player.m_iHealth')
	def SetArmor(self, amount):
		es.setplayerprop(self.userid, 'CPVK2Player.m_iHealth', amount)
	def SetAmmo(self, weapon, amount):
		es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_iAmmo.%s'%pvkAmmo[weapon], amount)
	def GetAmmo(self, weapon):
		return es.getplayerprop(self.userid, 'CBasePlayer.localdata.m_iAmmo.%s'%pvkAmmo[weapon])